main window does not maintain size clicking on status icon with gtk+ 3.7.10

February 25, 2013 10:50 - jef spera

Status: Rejected Start date: February 25, 2013

Priority: Minor Due date:  

Assignee:  % Done: 0%

Category: plugins/gtkui Estimated time: 0.00 hour

Target version:    

Affects version: 3.4-alpha1   

Description

I'm using Mate-1.4  gtk+3.7.10 audacious-3.4-alpha1.

How to reproduce:

1) Start audacious

2) Activate status icon plugin

3) Resize main window

4) Click twice on status icon

5) Now main window has a small size, so you can see only one song.

Audacious still works great with gtk+3.6.x

History

#1 - March 02, 2013 21:06 - John Lindgren

- Status changed from New to Rejected

Please do a Git bisect to find the GTK+ commit that caused the regression, and then report the bug to the GTK+ developers.

#2 - March 09, 2013 22:20 - John Lindgren

- Status changed from Rejected to New

- Target version deleted (3.4)

Thomas Lange did some debugging on this:

The bug appeared between GTK 3.7.4 and 3.7.6 with this commit:

https://git.gnome.org/browse/gtk+/commit/?id=b495ce5446a0bbf2ed63b5880537779e4b123515

So I asked the developer Benjamin Otte what could be wrong here.

He explained me that GTK 3.8 does not return the recent allocated size of a widget if it is invisible

(because a invisible widget should not have a valid size).

But that's the case here. And because of this the window size is the minimum.

 

I can't build development versions of GTK+ because my system does not have new enough dependencies, but maybe this will help someone find a

solution.

Reopening.
https://git.gnome.org/browse/gtk+/commit/?id=b495ce5446a0bbf2ed63b5880537779e4b123515


#3 - March 10, 2013 23:02 - Thomas Lange

- File ui_gtk.patch added

- Subject changed from main window doesn't mantain size clicking on status icon with gtk+3.7.10 to main window doesn&#x27;t mantain size clicking

on status icon with gtk+3.7.10

The attached patch fixes this.

If the window is visible (-> valid values), the size is stored.

And if the window becomes visible again, the size is restored.

#4 - March 10, 2013 23:04 - Thomas Lange

- Subject changed from main window doesn&#x27;t mantain size clicking on status icon with gtk+3.7.10 to main window doesn't mantain size clicking

on status icon with gtk+3.7.10

#5 - March 11, 2013 02:18 - John Lindgren

- Subject changed from main window doesn't mantain size clicking on status icon with gtk+3.7.10 to main window does not maintain size clicking on

status icon with gtk+ 3.7.10

- Category changed from libaudgui to plugins/gtkui

- Assignee deleted (jef spera)

Does GtkWindow forget its size after a gtk_widget_hide() + gtk_widget_show() cycle?  That seems wrong.

#6 - March 11, 2013 09:09 - jef spera

- File log_status_icon.txt added

The patch worked for me but there is another issue with status icon:

1 clear ./config/audacious

2 start audacious

3 check Status Icon in Preferences->Plugins->General

4 close audacious

5 the program ends with

Gtk:ERROR:gtkwidget.c:14122:gtk_widget_unregister_window: assertion failed: (user_data == widget)

and ~/.config/audacious/config is not updated

This happens with gtk+3.7.12 too.

In the meantime i went back to 2.5.4, gtk3/gnome3 apps are only for testing.

#7 - March 21, 2013 01:10 - John Lindgren

- Status changed from New to Rejected

John Lindgren wrote:

Does GtkWindow forget its size after a gtk_widget_hide() + gtk_widget_show() cycle?  That seems wrong.

June 14, 2025 2/3



 

Answering my own question: yes.  This is a regression in GTK+.  Benjamin Otte seemed to indicate on IRC that he plans to fix it for GTK+ 3.8.

#8 - March 30, 2013 00:23 - John Lindgren

Forwarded to https://bugzilla.gnome.org/show_bug.cgi?id=696882.

Files

ui_gtk.patch 975 Bytes March 10, 2013 Thomas Lange

log_status_icon.txt 4.09 KB March 11, 2013 jef spera
